﻿if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

if select(2, UnitClass("player")) ~= "DRUID" then
	return
end

local VERSION = tonumber(("$Revision: 62193 $"):match("%d+"))

local PitBull = PitBull
local PitBull_DruidManaBar = PitBull:NewModule("DruidManaBar", "LibRockEvent-1.0", "LibRockTimer-1.0")
local self = PitBull_DruidManaBar
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2008-02-20 04:15:33 -0500 (Wed, 20 Feb 2008) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local localization = (GetLocale() == "koKR") and {
	["Show a mana bar for your Druid when in Cat or Bear form."] = "드루이드의 표범 혹은 곰 변신 상태인 경우를 위한 마나바를 표시합니다.",
	["Druid mana"] = "드루이드 마나",
	["Druid mana bar"] = "드루이드 마나바",
	["Druid mana display settings for this unit type."] = "이 유닛 유형을 위한 드루이드 마나 표시 설정",
	["Show as deficit"] = "결손치로 표시",
	["Show druid's mana deficit, filling the bar when you use up your druidMana."] = "드루이드의 마나를 결손치로, 바를 채워 나가는 방식으로 표시합니다.",
	["Enable"] = "활성화",
	["Enables the druid mana bar."] = "드루이드 마나바를 활성화합니다.",
} or (GetLocale() == "zhCN") and {
	["Show a mana bar for your Druid when in Cat or Bear form."] = "PitBull 德鲁伊魔法监视条.",
	["Druid mana"] = "德鲁伊魔法监视",
	["Druid mana bar"] = "德鲁伊魔法监视条",
	["Druid mana display settings for this unit type."] = "显示该框架内德鲁伊魔法监视条.",
	["Show as deficit"] = "显示差值",
	["Show druid's mana deficit, filling the bar when you use up your druidMana."] = "显示德鲁伊魔法值的差值,当使用德鲁伊魔法监视条时填充.",
	["Enable"] = "启用德鲁伊魔法监视条",
	["Enables the druid mana bar."] = "启用德鲁伊魔法监视条.",
} or (GetLocale() == "zhTW") and {
	["Show a mana bar for your Druid when in Cat or Bear form."] = "當德魯伊在獵豹或者熊形態時顯示法力條.",
	["Druid mana"] = "德魯伊法力值",
	["Druid mana bar"] = "德魯伊法力條",
	["Druid mana display settings for this unit type."] = "此單位框架的德魯伊法力條設置.",
	["Show as deficit"] = "差額顯示",
	["Show druid's mana deficit, filling the bar when you use up your druidMana."] = "當你損失德魯伊法力值時, 以差額顯示的方式填充此條.",
	["Enable"] = "啟用",
	["Enables the druid mana bar."] = "啟用德魯伊法力條.",
} or {}

local L = PitBull:L("PitBull-DruidManaBar", localization)

self.desc = L["Show a mana bar for your Druid when in Cat or Bear form."]

local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

local UnitPowerType = UnitPowerType

PitBull_DruidManaBar:RegisterPitBullModuleDependencies("PowerBar")
PitBull_DruidManaBar:RegisterPitBullChildFrames('druidManaBar')
PitBull_DruidManaBar:RegisterPitBullBarLayoutHandler("druidManaBar", L["Druid mana bar"], L["Druid mana"])

local unitsShown = {}

local LibDruidMana

function PitBull_DruidManaBar:OnInitialize()
	self.db = PitBull:GetDatabaseNamespace("DruidManaBar")
	PitBull:SetDatabaseNamespaceDefaults("DruidManaBar", "profile", {
		deficit = false,
		hidden = false,
	})
end

function PitBull_DruidManaBar:OnEnable(first)
	LibDruidMana = Rock("LibDruidMana-1.0", false, true)
	if not LibDruidMana then
		error("PitBull_DruidManaBar requires LibDruidMana-1.0 to be available.")
	end
	self:AddEventListener("UNIT_DISPLAYPOWER")
	if first then
		LibDruidMana:AddListener(function(currMana, maxMana)
			if self:IsActive() then
				self:Update(nil, currMana, maxMana)
			end
		end)
	end
end

function PitBull_DruidManaBar:UNIT_DISPLAYPOWER(ns, event, arg1)
	if arg1 ~= "player" then
		return
	end
	if UnitPowerType("player") ~= 0 then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if not frame.druidManaBar then
				self:OnPopulateUnitFrame("player", frame)
				if frame.druidManaBar then
					PitBull:UpdateLayout(frame)
				end
			end
		end
	else	
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if frame.druidManaBar then
				self:OnClearUnitFrame("player", frame)
				PitBull:UpdateLayout(frame)
			end
		end
	end
end

function PitBull_DruidManaBar:UpdateColor(frame)
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			self:UpdateColor(frame)
		end
		return
	end
	
	local r,g,b = unpack(PitBull.colorConstants.mana)
	
	frame.druidManaBar:SetColor(r, g, b)
end

function PitBull_DruidManaBar:Update(frame, currMana, maxMana)
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if frame.druidManaBar then
				self:Update(frame, currMana, maxMana)
			end
		end
		return
	end
	
	local db = self.db.profile
	
	if maxMana ~= 0 then
		local perc = currMana / maxMana
		if db.deficit then
			perc = 1 - perc
		end
		frame.druidManaBar:SetValue(perc)
	end
end

function PitBull_DruidManaBar:OnUpdateFrame(unit, frame)
	if frame.druidManaBar then
		self:Update(frame, LibDruidMana:GetCurrentMana(), LibDruidMana:GetMaximumMana())
		self:UpdateColor(frame)
	end
end

function PitBull_DruidManaBar:OnPopulateUnitFrame(unit, frame)
	if unit ~= "player" or frame.druidManaBar or PitBull_DruidManaBar.db.profile.hidden or UnitPowerType("player") == 0 then
		return
	end
	local druidManaBar = newFrame("FakeStatusBar", frame)
	frame.druidManaBar = druidManaBar
	druidManaBar:SetTexture(PitBull:GetStatusBarTexture())
	druidManaBar:SetColor(0, 0, 1, 1)

	self:UpdateColor(frame)
end

function PitBull_DruidManaBar:OnClearUnitFrame(unit, frame)
	if frame.druidManaBar then
		frame.druidManaBar = delFrame(frame.druidManaBar)
	end
end

function PitBull_DruidManaBar:OnUpdateStatusBarTexture(texture)
	for _,frame in PitBull:IterateUnitFrames() do
		if frame.druidManaBar then
			frame.druidManaBar:SetTexture(texture)
		end
	end
end

function PitBull_DruidManaBar:OnUpdateLayout(unit, frame)
	local old = not unitsShown[frame]
	local now = not frame.druidManaBar or not frame.druidManaBar:IsShown()
	if old == now then
		return
	end
	unitsShown[frame] = not now
	if not now then
		self:OnUpdateFrame(unit, frame)
	end
end

local function getDeficit()
	return PitBull_DruidManaBar.db.profile.deficit
end
local function setDeficit(value)
	PitBull_DruidManaBar.db.profile.deficit = value

	for frame in PitBull:IterateUnitFramesForUnit("player") do
		if frame.druidManaBar then
			PitBull_DruidManaBar:Update(frame)
		end
	end
end
local function getHide()
	return PitBull_DruidManaBar.db.profile.hidden
end
local function getEnabled()
	return not PitBull_DruidManaBar.db.profile.hidden
end
local function setEnabled(value)
	value = not value
	PitBull_DruidManaBar.db.profile.hidden = value
	
	for frame in PitBull:IterateUnitFramesForUnit("player") do
		if value then
			self:OnClearUnitFrame("player", frame)
		else
			self:OnPopulateUnitFrame("player", frame)
			self:OnUpdateFrame("player", frame)
		end
		PitBull:UpdateLayout(frame)
	end
end
PitBull_DruidManaBar:RegisterPitBullOptionsMethod(function(group)
	if group == "player" then
		return {
			name = L["Druid mana"],
			desc = L["Druid mana display settings for this unit type."],
			type = 'group',
			args = {
				deficit = {
					type = 'boolean',
					name = L["Show as deficit"],
					desc = L["Show druid's mana deficit, filling the bar when you use up your druidMana."],
					get = getDeficit,
					set = setDeficit,
					disabled = getHide,
				},
				hide = {
					type = 'boolean',
					name = L["Enable"],
					desc = L["Enables the druid mana bar."],
					get = getEnabled,
					set = setEnabled,
					order = 1,
				},
			}
		}
	end
end)
